var commonFunctions = require('./commonFunctions.js')


function convertOldUIResults(resultsJson, overwriteUS, userstory) {
    let convertedJSON = []
    for( let feature of resultsJson) {
        let convertedFeatureJson = {};
        let rallyDetsAtFeature = feature.name.split(":");
        let tsValue = '', rfValue = '', pnValue = '', featureName = '', setAgain = false, tsSet = false;
        for ( let detIndex = 0; detIndex < rallyDetsAtFeature.length ; detIndex++ ) {
            let rallyInfo = rallyDetsAtFeature[detIndex].trim();
            let tsPattern = /^TS[0-9]+$/ ;
            if ( tsPattern.test(rallyInfo.trim()) && !tsSet) {
                setAgain = true;
                tsValue = rallyInfo.match(tsPattern)[0];
                tsSet = true;
            } else if ( rallyInfo.startsWith("RF-")) {
                setAgain = true;
                rfValue = rallyInfo.substring(3);
            } else if ( rallyInfo.startsWith("PN-")) {
                setAgain = true;
                pnValue = rallyInfo.substring(3);
            } else {
                if(!setAgain) {
                    featureName += rallyInfo;
                } else {
                    featureName = rallyInfo;
                }
                setAgain = !setAgain;
            }
        }
        convertedFeatureJson.name = featureName + "(**" + (tsValue ? "TestSetid = " + tsValue +",": "" )+ (rfValue ? "FolderPath = " + rfValue +"," : "") + ( pnValue ? "ProjectName =" + pnValue + "," : "") + "**)";
        convertedFeatureJson.uri = feature.uri;
        convertedFeatureJson.keyword = feature.keyword;
        convertedFeatureJson.elements = [];
        let setAgainAtSc = false;
        for ( let scenario of feature.elements ) {
            let convertedScenarioJson = {};
            convertedScenarioJson.keyword = scenario.keyword;
            let rallyDets = scenario.name.split(":");
            let usValues , tcValue = '', dfValue = '' , scName  = '', usSet = false, tcSet = false, dfSet = false;
            for ( let detIndex = 0; detIndex < rallyDets.length ; detIndex++ ) {
                let rallyInfo = rallyDets[detIndex].trim();
                let usPattern = /^US[0-9]+$/ ,hasUSPatten = /US[0-9]+/g;
                let dfPattern = /^DE[0-9]+$/ ;
                let tcPattern = /^TC[0-9]+$/;
                if ( hasUSPatten.test(rallyInfo) && !usSet) {
                    usValues = rallyInfo.split(",");
                    let correctUS = true;
                    for ( let usVal of usValues ) 
                        if(usVal.trim().match(usPattern)) continue;
                        else { correctUS = false; break;}
                    if ( !correctUS ) {
                        if(!setAgainAtSc) {
                            scName += rallyInfo;
                        } else {
                            scName = rallyInfo;
                        }
                        setAgainAtSc = !setAgainAtSc;
                    } else {
                        usSet = true;
                        setAgainAtSc = true;
                    }
                } else if ( tcPattern.test(rallyInfo.trim()) && !tcSet ) {
                    setAgainAtSc = true;
                    tcValue = rallyInfo;
                    tcSet = true;
                } else if ( dfPattern.test(rallyInfo.trim()) && !dfSet ) {
                    setAgainAtSc = true;
                    dfValue = rallyInfo;
                    dfSet = true;
                } else {
                    if(!setAgainAtSc) {
                        scName += rallyInfo;
                    } else {
                        scName = rallyInfo;
                    }
                    setAgainAtSc = !setAgainAtSc;
                }
            }
            let tagsOfSc ='';
            if(scenario.tags) {
                for ( let tag of scenario.tags ) {
                    tagsOfSc += tag.name.replace(/@/g, "") + "|";
                }
            }

            convertedScenarioJson.steps = [];
            let description = ''; let stepsCount = 1;
            for ( let stepIndex = 0; stepIndex < scenario.steps.length ; stepIndex++) {
                let stepJson = {};
                stepJson.result = scenario.steps[stepIndex].result;
                stepJson.name = scenario.steps[stepIndex].name;
                if(scenario.steps[stepIndex].keyword.trim() != 'After' && scenario.steps[stepIndex].keyword.trim() != 'Before' ) {
                    description += "<br>"  + stepsCount + ". " + stepJson.name;
                    stepsCount++;
                }
                convertedScenarioJson.steps.push(stepJson);
            }
            if (!usValues  || usValues.length <= 1 || ((overwriteUS === true || overwriteUS === 'true') && ( userstory))) {
                let formattedSCName = scName + "(**" + (dfValue ? "defectId = " + dfValue +",": "" ) +  (tcValue ? "testcaseId = " + tcValue +",": "" ) + ((usValues) ? "UserStory = " + usValues[0] +",": "" ) + (tagsOfSc != '' ? "tags =" + tagsOfSc.substring(0,tagsOfSc.length-1)+"," : "" ) + (description != '' ? "Description = " + description.replace(/,/g, " and ").replace(/=/g, " equals ") +",": "" )  +"**)";
                convertedScenarioJson.name =  formattedSCName;
                convertedFeatureJson.elements.push(convertedScenarioJson);
            } else {
                for ( let [index, usValue] of usValues.entries() ) {
                    let anotherScenario;
                    let formattedSCName = scName + "_us" + (index + 1) + "(**" + (usValue ? "UserStory = " + usValue +",": "" ) + (tagsOfSc != '' ? "tags =" + tagsOfSc.substring(0,tagsOfSc.length-1)+"," : "" ) + (description != '' ? "Description = " + description.replace(/,/g, " and ").replace(/=/g, " equals ") +",": "" )  +"**)";
                    convertedScenarioJson.name =  formattedSCName;
                    anotherScenario = JSON.parse(JSON.stringify(convertedScenarioJson));
                    convertedFeatureJson.elements.push(anotherScenario);
                }
            }
        }
        convertedJSON.push(convertedFeatureJson);
    }
    return convertedJSON;
}

function convertNewUIResults(resultsJson, overwriteUS, userstory) {
    let convertedJSON = []
    for( let feature of resultsJson) {
        let convertedFeatureJson = {};
        convertedFeatureJson.name = feature.name;
        convertedFeatureJson.uri = feature.uri;
        convertedFeatureJson.keyword = feature.keyword;
        convertedFeatureJson.elements = [];
        for ( let scenario of feature.elements ) {
            adaptRallyAttrInNewFormat(convertedFeatureJson, scenario.keyword, scenario.name, scenario.steps, scenario.tags, overwriteUS, userstory)
        }
        convertedJSON.push(convertedFeatureJson);
    }
    return convertedJSON;

}

function adaptRallyAttrInNewFormat(convertedFeatureJson, keyword, scenario_name, steps, tags, overwriteUS, userstory) {
    let convertedScenarioJson = {};
    convertedScenarioJson.keyword = keyword;
    let usValues = [], description = '', scenarioName, scenarioLevelRallyAttr = {};
    if (scenario_name.includes('(**') && scenario_name.includes('**)')) {
        rallyAttrStr = scenario_name.substring(scenario_name.indexOf('(**') + 3, scenario_name.indexOf('**)'));
        scenarioName = scenario_name.substring(0, scenario_name.indexOf('(**')).trim();
        scenarioLevelRallyAttr = commonFunctions.splitString(rallyAttrStr, ',');
    } else {
        scenarioName = scenario_name;
    }
    if(scenarioLevelRallyAttr.hasOwnProperty("userstory")) {
        usValues = scenarioLevelRallyAttr["userstory"].split("|");
    }
    if( tags ) {
        let tagsOfSc ='';
        for ( let tag of tags ) {
            tagsOfSc += tag.name.replace(/@/g, "") + "|";
        }  
        scenarioLevelRallyAttr["tags"] =  scenarioLevelRallyAttr["tags"] ? scenarioLevelRallyAttr["tags"] + "|" + tagsOfSc : tagsOfSc;
    }
    convertedScenarioJson.steps = [];
    let stepsCount = 1;
    for ( let step of steps) { 
        let stepJson = {};
        stepJson.result = step.result;
        stepJson.name = step.name;
        if(step.keyword.trim() != 'After' && step.keyword.trim() != 'Before' ) {
            description += "<br>"  + stepsCount + ". " + step.name;
            stepsCount++;
        }
        convertedScenarioJson.steps.push(stepJson);
    }
    description = description.replace(/,/g, " and ").replace(/=/g, " equals ");
    scenarioLevelRallyAttr["description"] =  scenarioLevelRallyAttr["description"] ? scenarioLevelRallyAttr["description"] + "<br>" + description : description;
    if (usValues.length <= 1 || ((overwriteUS === true || overwriteUS === 'true') && ( userstory))) {
        let rallyAttrArrStr = '';
        for( [key, value] of Object.entries(scenarioLevelRallyAttr)){
            rallyAttrArrStr += key + "=" + value;
            rallyAttrArrStr += ",";
        }
        let formattedSCName = scenarioName + "(**" +  rallyAttrArrStr +"**)";
        convertedScenarioJson.name =  formattedSCName;
        convertedFeatureJson.elements.push(convertedScenarioJson);
    } else {
        let rallyAttrArrStr = '';
        for( [key, value] of Object.entries(scenarioLevelRallyAttr)) {
            if (key === "userstory" || key === 'testcaseid' || key === 'defectid') continue;
            rallyAttrArrStr += key + "=" + value;
            rallyAttrArrStr += ",";
        }
        for ( let [index, usValue] of usValues.entries() ) {
            let anotherScenario;
            let tempRallyAttrStr = rallyAttrArrStr + "userstory=" + usValue;
            let formattedSCName = scenarioName + "_us" + (index + 1) + "(**" + tempRallyAttrStr  +"**)";
            convertedScenarioJson.name =  formattedSCName;
            anotherScenario = JSON.parse(JSON.stringify(convertedScenarioJson));
            convertedFeatureJson.elements.push(anotherScenario);
        }
    }
}

module.exports = { convertOldUIResults, convertNewUIResults}



